/*************************************/
/* Moteur de recherche en profondeur */
/*************************************/

/* Test pour l'atteinte de l'objectif */
rechpf(ETAT, _, [])                         :-  final(ETAT).

/* Boucle de recherche en profondeur */
rechpf(ECOURANT, DEJAFAIT, [OPER|OPERSUIV]) :-
  op(ECOURANT, OPER, ESUIVANT),                   /* Acquisition de l'etat suivant */
  not(interdit(ESUIVANT)),                        /* Est-il interdit ? */
  not(member(ESUIVANT, DEJAFAIT)),                /* A-t-il deja ete traite ? */
  write(ECOURANT),                                /* Info a l'ecran */
  rechpf(ESUIVANT,[ECOURANT|DEJAFAIT], OPERSUIV). /* On relance */

/* Fonction de lancement : cherche(X). */
cherche(OPERSUIV)                          :-
  init(ETATI),
  nl,
  write('Etats testes :'),
  nl, 
  rechpf(ETATI, [ETATI], OPERSUIV),
  nl.


/***************************************/
/* Donnees specifiques au pb du berger */
/***************************************/

/* Etats initial et final : [RiveBerger, RiveLoup, RiveChevre, RiveChou] */
init([g, g, g, g]).
final([d, d, d, d]).

/* Etats interdits */
interdit([RIVE, _, RIVEOPP, RIVEOPP])   :-
 changeRive(RIVE, RIVEOPP). /* Chevre et chou sur la meme rive */
interdit([RIVE, RIVEOPP, RIVEOPP, _])   :-
 changeRive(RIVE, RIVEOPP). /* Loup et chevre sur la meme rive */

/* Operations */
op([RIVE, LOUP, CHEVRE, CHOU], fermierSeul, [RIVEOPP, LOUP, CHEVRE, CHOU])     :-  
 changeRive(RIVE, RIVEOPP). /* Le fermier traverse seul */
op([RIVE, RIVE, CHEVRE, CHOU], fermierLoup, [RIVEOPP, RIVEOPP, CHEVRE, CHOU])  :-
 changeRive(RIVE, RIVEOPP). /* Le fermier fait traverser le loup */
op([RIVE, LOUP, RIVE, CHOU], fermierChevre, [RIVEOPP, LOUP, RIVEOPP, CHOU])    :-
 changeRive(RIVE, RIVEOPP). /* Le fermier fait traverser la chevre */
op([RIVE, LOUP, CHEVRE, RIVE], fermierChou, [RIVEOPP, LOUP, CHEVRE, RIVEOPP])  :-
 changeRive(RIVE, RIVEOPP). /* Le fermie fait traverser le chou */

/* Changements de rive */
changeRive(g, d).
changeRive(d, g).
