/*************************************/
/* Moteur de recherche en profondeur */
/*************************************/

/* Test pour l'atteinte de l'objectif */
rechpf(ETAT, _, [])                         :-  final(ETAT).

/* Boucle de recherche en profondeur */
rechpf(ECOURANT, DEJAFAIT, [OPER|OPERSUIV]) :-
  op(ECOURANT, OPER, ESUIVANT),                   /* Acquisition de l'etat suivant */
  not(interdit(ESUIVANT)),                        /* Est-il interdit ? */
  not(member(ESUIVANT, DEJAFAIT)),                /* A-t-il deja ete traite ? */
  write(ECOURANT),                                /* Info a l'ecran */
  rechpf(ESUIVANT,[ECOURANT|DEJAFAIT], OPERSUIV). /* On relance */

/* Fonction de lancement : cherche(X). */
cherche(OPERSUIV)                          :-
  init(ETATI),
  nl,
  write('Etats testes :'),
  nl,
  rechpf(ETATI, [ETATI], OPERSUIV),
  nl.


/***********************************************/
/* Donnees specifiques au pb des missionnaires */
/***********************************************/

/* Etats initial et final : [NbMissio a gauche, NbCanni a gauche, Rive ou se trouve la barque */
init([3, 3, g]).
final([0, 0, d]).

/* Etats interdits */
interdit([NBMISS, NBCANNI, _])   :-
 NBMISS>3 ; NBCANNI>3.      /* Limite physique du pb : nombres < 3 */
interdit([NBMISS, NBCANNI, _])   :-
 NBMISS<0 ; NBCANNI<0.      /* Limite physique du pb : nombres > 0 */
interdit([NBMISS, NBCANNI, _])   :-
 NBMISS<NBCANNI, NBMISS>0.  /* Plus de cannibales que de missionnaires sur la rive gauche*/
interdit([NBMISS, NBCANNI, _])   :-
 NBMISS=:=1, NBCANNI=:=0.   /* Rive droite : 2 Miss et 3 Canni */
interdit([NBMISS, NBCANNI, _])   :-
 NBMISS=:=2, NBCANNI<2.     /* Rive droite : 1 Miss et 2 ou 3 Canni */

/* Operations */
op([NBMISS, NBCANNI, g], unCanniGD, [NBMISS, NBCANNI2, d])          :-
 NBCANNI2 is (NBCANNI-1).
op([NBMISS, NBCANNI, d], unCanniDG, [NBMISS, NBCANNI2, g])          :-
 NBCANNI2 is (NBCANNI+1).
op([NBMISS, NBCANNI, g], deuxCanniGD, [NBMISS, NBCANNI2, d])        :-
 NBCANNI2 is (NBCANNI-2).
op([NBMISS, NBCANNI, d], deuxCanniDG, [NBMISS, NBCANNI2, g])        :-
 NBCANNI2 is (NBCANNI+2).
op([NBMISS, NBCANNI, g], unMissiGD, [NBMISS2, NBCANNI, d])          :-
 NBMISS2 is (NBMISS-1).
op([NBMISS, NBCANNI, d], unMissiDG, [NBMISS2, NBCANNI, g])          :-
 NBMISS2 is (NBMISS+1).
op([NBMISS, NBCANNI, g], deuxMissiGD, [NBMISS2, NBCANNI, d])        :-
 NBMISS2 is (NBMISS-2).
op([NBMISS, NBCANNI, d], deuxMissiDG, [NBMISS2, NBCANNI, g])        :-
 NBMISS2 is (NBMISS+2).
op([NBMISS, NBCANNI, g], unCanniUnMissiGD, [NBMISS2, NBCANNI2, d])  :-
 NBMISS2 is (NBMISS-1), NBCANNI2 is (NBCANNI-1).
op([NBMISS, NBCANNI, d], unCanniUnMissiDG, [NBMISS2, NBCANNI2, g])  :-
 NBMISS2 is (NBMISS+1), NBCANNI2 is (NBCANNI+1).

